#include <bits/stdc++.h>

using namespace std;

char niz[100005];
int pref[26][100005];

int k;

int koliko(int l) {
    cin >> niz[l];
    bool sviIsti = false;
    int koliko;
    for(int i = 0; i < k; i++) {
        if(l == 0) pref[i][l] = (int)niz[l] == i + (int)'a';
        else pref[i][l] += pref[i][l - 1] + ((int)niz[l] == i + (int)'a');
        if(i == 0) koliko = pref[i][l];
        else if(koliko != pref[i][l]) {
            bool sviIsti = false;
            koliko = min(koliko, pref[i][l]);
        }
    }
    return koliko + 1;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int n;
    cin >> n >> k;
    for(int i = 0; i < n; i++) {
        cout << koliko(i) << " ";
    }
    return 0;
}
/*
7 3
bbcbaca
*/